// Avant de placer une nouvelle equipe, on trie les tables par capacite
// restante decroissante, et on place l'equipe sur les premieres tables.
// Puis on itere.
// Passe le juge UVa.

#include <iostream>
#include <stdlib.h>

#define M 70 // nb max equipes
#define N 50 // nb max tables

int table[N];

int comparaison(const void * i1, const void * i2)
{
  int i = *((int *) i1);
  int j = *((int *) i2);
  return table[j]-table[i];
}

int main()
{
  int n_equipes, n_tables;
  int equipe[M];
  int table_triee[N];
  int solution[M][N];
  bool fin;

  std::cin >> n_equipes >> n_tables;

  while (n_equipes != 0 || n_tables != 0)
    {
      fin = false;
      // lecture des entrees
      for (int i=0; i < n_equipes; ++i)
	std::cin >> equipe[i];
      
      for (int j=0; j < n_tables; ++j)
	std::cin >> table[j];

      for (int i=0; i<n_tables; ++i)
	table_triee[i] = i;

      for (int i=0; i<n_equipes; ++i)
	{
	  qsort(table_triee, n_tables, sizeof(int), comparaison);

	  for (int j=0; j<equipe[i]; ++j)
	    if (j >= n_tables || table[table_triee[j]] <= 0)
	      {
		std::cout << 0 << std::endl;
		fin = true; break;
	      }
	    else
	      {
		--table[table_triee[j]];
		solution[i][j] = table_triee[j];
	      }

	  if (fin)
	    break;

	}

      if (fin)
	{
	  std::cin >> n_equipes >> n_tables;
	  continue;
	}
      // afficher la solution
      std::cout << 1 << std::endl;
      for (int i=0; i<n_equipes; ++i)
	{
	  for (int j=0; j<equipe[i]-1; ++j)
	    std::cout << 1+solution[i][j] << ' ';
	  std::cout << 1+solution[i][equipe[i]-1] << std::endl;
	}
      std::cin >> n_equipes >> n_tables;
    }

}
